<Cfscript>

//<!--- CREATE THE SOAP OBJECT --->
vr = createObject("webservice", "https://api.verticalresponse.com/wsdl/1.0/VRAPI.wsdl");

//<!--- LOGIN --->
WriteOutput("<p><b>Logging into VR...</b></p>");
vr_loginarray = StructNew();
StructInsert(vr_loginarray, "username", "");
StructInsert(vr_loginarray, "password", "");
StructInsert(vr_loginarray, "session_duration_minutes", "2");
session_id = vr.login(vr_loginarray);
WriteOutput("<p><b>Session Id: " & session_id & "</b></p>");




//<!--- Enumerate (limit) campaigns --->
limit = 5;
NVPair_order = StructNew();
StructInsert(NVPair_order, "field_name", "last_updated");
StructInsert(NVPair_order, "direction", "asc");

order_by_fields[1] = NVPair_order;
statuses[1] = "sent";

enumerateEmailCampaignArgs = StructNew();
StructInsert(enumerateEmailCampaignArgs, "session_id", session_id);
StructInsert(enumerateEmailCampaignArgs, "limit", 5);
StructInsert(enumerateEmailCampaignArgs, "order_by_fields", order_by_fields);
StructInsert(enumerateEmailCampaignArgs, "statuses", statuses);

all_sent_campaigns = vr.enumerateEmailCampaigns(enumerateEmailCampaignArgs);

//CFDUMP(all_sent_campaigns);

for (i=1; i LTE ArrayLen(all_sent_campaigns); i = i +1){
	getEmailCampaignStatsArgs = StructNew();
	StructInsert(getEmailCampaignStatsArgs, "session_id", session_id);
	StructInsert(getEmailCampaignStatsArgs, "campaign_id",all_sent_campaigns[i].getId() );
    StructInsert(getEmailCampaignStatsArgs, "include_link_stats", false);
	emailCampaignStats = vr.getEmailCampaignStats(getEmailCampaignStatsArgs);
	
//    CFDUMP(emailCampaignStats);	
      WriteOutput("</p>");
      WriteOutput("<b>Campaign Name: " & emailCampaignStats.getCampaign_name() & "</b><br><ul>");
      WriteOutput("<li>List ID: " & emailCampaignStats.getCampaign_id() & "<br>");
      WriteOutput("<li>Sent Date: " & emailCampaignStats.getSent_date() & "<br>");
      WriteOutput("<li>Open Count: " & emailCampaignStats.getOpen_count() & "<br>");
      WriteOutput("<li>Multiple-Open Count: " & emailCampaignStats.getReopen_count() & "<br>");
      WriteOutput("<li>Click Count: " & emailCampaignStats.getClick_count() & "<br>");
      WriteOutput("<li>Bounce Count: " & emailCampaignStats.getBounce_count() & "<br>");
      WriteOutput("<li>Unsubscribe Count: " & emailCampaignStats.getUnsub_count() & "<br>");
      WriteOutput("</ul></p>");
}
</cfscript>

<cffunction name= "CFDUMP" returntype="boolean" output="yes">
  <cfargument name="value" type="any" default="nothing to output">
  <CFDUMP var="#arguments.value#">
  <cfoutput><p /></cfoutput>
  <cfreturn true>       
</cffunction>



